<?php
# This file was created by the Placename Format mod
$tngModNames['Placename Format']['rrplacenameformat_help.php'] = '4'; #Register this mod

include("../../helplib.php");
echo help_header("Help: Placename Formatting and Related Programs");
$imagepath = "";
?>

<body class="helpbody">

<script>
//Hide an element if it is visible and vice versa
function toggleElement(elementID) {
	if (document.getElementById(elementID).style.display == 'block')
		document.getElementById(elementID).style.display = 'none';
	else
		document.getElementById(elementID).style.display = 'block';
}
</script>
<style>
	ul.p li{margin-top:1ex; margin-bottom:1ex;} /*Paragraph spacing in an unordered list*/
	ol.p li{margin-top:1ex; margin-bottom:1ex;} /*Paragraph spacing in an ordered list*/
	ol.doublespace>li{margin-top:1ex;margin-bottom:1ex;}
	p.code {margin-top:0; margin-bottom;0; margin-left:2em; font-family:monospace;}
	.codeblock {float:left; font-family:monospace; border:thin solid grey;padding:0 0.5em; margin:0.0.5em;}
	.left {float:left;}
	.comment {font-family:serif; background-color:linen;}
</style>

<table id='top' width="100%" border="0" cellpadding="10" cellspacing="2" class="tblback normal">
<tr class="fieldnameback">
	<td class="tngshadow">
		<p style="float:right; text-align:right" class="smaller menu">
			<a href="http://tngforum.us" target="_blank" class="lightlink">TNG Forum</a> &nbsp; | &nbsp;
			<a href="http://tng.lythgoes.net/wiki" target="_blank" class="lightlink">TNG Wiki</a><br />
			<a href="places_help.php" class="lightlink">&laquo; Help: Places</a> &nbsp; | &nbsp;
		</p>
		<span class="largeheader">Help: Placename Formatting</span>
		<p class="smaller menu">
			<a href="#overview" class="lightlink">Overview</a> &nbsp; | &nbsp;
			<a href="#placelevel" class="lightlink">Place Level Utility</a> &nbsp; | &nbsp;
			<a href="#placeoptions" class="lightlink">Place Options Utility</a> &nbsp; | &nbsp;
			<a href="#options" class="lightlink">Placename Formatting Options</a>
		</p>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<h2id='overview'>Overview</h2>
		<p>This help file describes the programs and options that are installed by the Placename Format mod,
		and are accessible through tabs in the Administration >> Places pages. The unifying feature of these utilities is the <b>Placename Formatting</b> process that
		<ol>
		<li>Makes sure that USA places are consistent in the way that they express the country, the state, and the county.</li>
		<li>Knows state names and abbreviations,</li>
		<li>Recognizes locales such as "East Texas", "Ohio or Kentucky", and "New England" that are not states, but that act like states in the place hierarchy.", which are not counties, but , "Merges redundant Placenames such as "Houston, TX", "Houston, Harris County, Texas, United States", "Houston, Harris, Texas", and so on,</li>
		<li>Recognizes locales such as "Long Island" and "Shenandoah Valley" that are not counties (and shouldn't have the word "County" appended to them), but which act like counties in the place hierarchy, and</li>
		<li>Recognizes funky census locations such as  such as "Magisterial District 10", "Beat 5", "Civil District 8", etc., and deals with them appropriately.</li>
		</ol>
		<p>In order for the formatting to work, the process has to know if a Placename is in the USA.
			To do this, it looks at the last element (that is the last "comma-part") of the Placename, which must be either 
			<ol><li>A string that specifies the USA; i.e. "USA", "U.S.A.", "United States", etc.,
				<li>A USA state name or abbreviation (e.g. Alabama, AL, Texas, TX, etc.), or</li>
				<li>Specified "non-states", or what I sometimes call "pseudo-states")<br>
					The notion of a non-state lets the Placename Formatting process recognize terms like "East Tennessee", "North Georgia", "New England", "Alabama or Mississippi", etc. as though they were real U.S. states.</li>
			</ol>
			The USA strings and the list of non-standard USA states are configurable options.  
		</p>
		<p>Significantly - although the Placename Formatting options and the PHP code that formats places are installed by the Placename Format mod,
		 as of early December, 2017, the Placename Formatting code is executed only through the Gedcom Converter, which is installed by the Gedcom Converter Mod.  
	</td>
</tr>

<tr class="databack">
	<td class="tngshadow" id='placelevel'>
		<p style="float:right"><a href="#top">Top</a></p>
		<h2 id='placelevel'>Place Level Utility at Admin >> Places >> Placelevel</h2>
		<p>This utility sets the place levels for USA places and for non-USA placenames that just consist of a country name.
		On a kickoff form, you can tell it
		<ol><li>Which tree to process (or all trees), and
			<li>What to do:
				<ol type='a'>
				<li>Calculate a Placelevel for all Places,</li>
				<li>Process only Only Places whose Placelevel is not defined (i.e. is zero or null), or</li>
				<li>Reset all Plavelevel values to zero</li>
				</ol>
			</li>
		</ol>
		<p>
		The USA placenames must be formatted according to the Placename Formatting options, 
		which control the way that Placenames express the country, the state, 
		and the county.
		For instance, USA placenames must end with the representation of USA specified in the options,
		and the state name for states with subordinate locales (e.g. a county or city) must be consistently either abbreviated or not, 
		as specified by another option.
		</p>
		<p>Among non-USA placenames, if there is no comma in the placename, it is identified as a country. 
		But the Placelevels for all other non-USA placenames is left undefined.</p>
		<p>The program displays a list of the non-USA places that it could not process, 
		and their current Placelevel. 
	</td>
</tr>

<tr class="databack">
	<td class="tngshadow" id='placelevel'>
		<p style="float:right"><a href="#top">Top</a></p>
		<h2 id='placeoptions'>Placename Formatting Options Utility at Admin >> Places >> Options</h2>
		<p>These options control:
		<ol><li>The Placename Formatting process re-formats USA Placenames <em>in a Gedcom file, during the Gedcom Conversion process</em>.
			Reformatted placenames are consistent in the way they express 
				<ol type='a'>
				<li>The country (e.g. possibly always "USA" rather than a mix of "USA", "United States", etc.),
				<li>The state name or abbreviation, and
				<li>The county - particularly the "county designator" such as "County" or "Parish").</li>
				</ol></li>
			<li>and the Place Level-assignment process for USA Placenames in the news- Place Level utility described above.</li>
		</ol>
		The Placename Formatting Options also 
		<ol><li>Specify substrings that identify burial places for use by the Admin>>Cemeteries and Admin>>Places,</li>
			<li>Specify substrings that identify certain funky census places (such as "Civil District 10, Barr County, Ohio) that are not really towns, and that don't contribute to geocoding,<li>
			<li>Specify other substrings that identify place-parts in placenames.
			<li>Assign place levels to USA Placenames in the Place Level utility described above, and</li>
		</ol>
		Note that (at least for now), the Placename Formatting process only affect USA places
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<p style="float:right"><a href="#top">Top</a></p>
		<h2 id="options">Placename Formatting Options</h2>
		<p>The Placename Formatting Options are stored in the configuration file rrplacenameformat_config.php in the TNG extensions folder.  They can be edited through the new "Format Options" tab at Admin>>Places, and as part of the Gedcom Converter kickoff form (i.e. the "Converter" tab under Admin>>Import/Export).</p>
		<p>The options are broken out into three groups, and there are "Save Place Options" buttons at the top and the bottom of the form. </p>
		<fieldset><legend>Placename Formatting Options</legend>
		<div style='text-align:right;'><input type='button' value='Save Place Options' disabled/></div>
			<div class='comment'><b>This button does not submit the form</b>.
			Instead, it uses Ajax to save the Place Options to their config file 
			<i>without</i> submitting the form. You can thus use options that you do not save. 
			A separate "Convert Gedcom File" submit button 
			(placed outside of the Fieldset boxes that encloses the options) submits the form,
			and passes the options in the both subforms to the Gedcom Converter.</div>
		<h4>A. Names for the USA, 'non-States', and 'non-Counties'</h4>
		<ol>
			<li><label>Text that can represent the USA. (Not case-sensitive; Separate with commas)<br>
				<textarea disabled rows='1' cols='60'>USA, United States of America, U.S.A., United States</textarea></label>
				<div class='comment'>A placename that <em>ends with</em> any of these strings (as a full "place-part") is immediately recognized as a USA place.</div>
				</li>
			<li><button onclick="toggleElement('nonstates');">Modify List of 'non-States'</button> 
				<span class='comment'>&lt;&lt;Click the button to show and hide the subform>></span>
				<div class='comment'>Non-states are named regions that act like states in placenames, but that aren't USA states. All 50 U.S. States are automatically defined as 'States', but the District of Columbia and the U.S. territories and protectorates (Puerto Rico, Guam, etc.) are not. Placees such as 'New England' or 'TN or SC' can also be defined as non-states for the purpose of formatting placenames. ('Non-states' can have cities and cemeteries, but cannot have counties.)
				<p>The list of Non-Standard States is be edited in a two column subform behind the button.  Each Non-Standard State must have a name and an abbreviation. Note that some of the abbreviations I have defined are identical to the names.
				<div id='nonstates' style='display:none;'><img src='rrplacenameformat_states.png' alt='screenshot of the Non-States subform'></div>
			</li>
			<li><button onclick="toggleElement('noncounties');">Modify List of non-Counties</button>
				<span class='comment'>&lt;&lt;Click the button to show and hide the subform>></span>
				<div class='comment'>
				When the Placename Formatting process sees a placename such as "Cleveland, Cuyahoga, Ohio", it recognizes "Cuyahoga" as a county name, and (depending on the county designator options below), it may try to add the word "County" to it. 
				To avoid changing names such as "Flatbush, Brooklyn, NY" to "Flatbush, Brooklyn County, New York" or "Seaford, Long Island, NY" to "Seaford, Long Island County, New York", while still
				allowing "Brooklyn, Michigan" to act as a county, you can enter Brooklyn,NY; Long Island,NY, and similar locales into the non-Counties subform.
				<p>Note that the presence of a state <i>abbreviations</i> in the definition of "non-counties" does not mean that placenames with "non-counties" in the <em>old</em> Gedcom file must use the state abbreviation;
				The Placename Formatting process knows about state names <i>and</i> abbreviations, so it can deal with a placename that uses either the abbreviation or the full name.</p></div>
				<div id='noncounties' style='display:none;'><img src='rrplacenameformat_counties.png' alt='screenshot of the Non-Counties subform'></div>
			</li>
		</ol>
		<h4>B. Strings that identify special cases of the City component of a Placename</h4>
		<ol start='4'>
			<li class='p'>a. <label><b>Strings that identify burial places (Not case-sensitive; Separate with commas):</b><br />
				<textarea disabled rows='2' cols='60'>cemetery, memorial park, memorial garden, churchyard, graveyard, burial ground, burying ground, burial site, mausoleum</textarea></label>
				<br/>b. <b>What to do with Burial Place names in the City position</b>
				<br/><label><input type='radio' disabled checked />Leave them in the City position, but assign them the Location placelevel</label>
				<br/><label><input type='radio' disabled />Remove them</label>
				<br/><label><input type='radio' disabled />Move them to the Location position (i.e. leave the City blank)</label>
				<br/><label><input type='radio'disabled />Move them to the Event description or note</label>
				<div class='comment'>
					This option serves at least two purposes. 
					First, when a placename specifies a burial place in a county but not in a town,
					this option allows the Placename Formatting process <i>and</i> the Place Levels utility
					(described below) to recognize the the burial place as a location rather than a town,
					and thus
					<ul>
						<li>The Placename Formatting process can make sure that the county name includes the county designator (if it isn't a non-county as specified above), and</li>
						<li>The Placelevel utility can assign it the Placelevel value for "location" rather than "city/town".</li>
					</ul>
					<p>Second, the Cemetery Edit mod changes the Cemetery editor so that it can match the cemetery name being entered with Place names that specify burial places.</p>
					<p>Note that, unlike the USA text option, the non-states, and the non-counties, these strings are just substrings within a place-part.</p>
				</div>
			</li>
			<li class='p'>a. <label><b>Strings that identify places within counties that are not towns. (Not case-sensitive, etc.):</b><br />
				<textarea disabled rows='1' cols='60'>in battle, battle of</textarea></label>
				<br/>b. <b>What to do with these 'Non-cities':</b>
				<br/><label><input type='radio' disabled />Leave them in the City position and assign the City placelevel</label>
				<br/><label><input type='radio' disabled />Leave them in the City position, but assign them the Location placelevel</label>
				<br/><label><input type='radio' disabled checked />Leave them in the City position, but assign them the County placelevel</label>
				<br/><label><input type='radio' disabled />Remove them</label>
				<br/><label><input type='radio' disabled />Move them to the Location position (i.e. leave the City blank)</label>
				<br/><label><input type='radio' name='cemeteryToDo' value='note'/>Move them to the Event description or note</label>
				<div class='comment'>This option is similar to the Cemeteries option above, but isn't nearly as important.  I actually implemented it before I realized that I didn't have much use for it. It really affects only two placenames in my database. One is "Battle of Franklin, Franklin County, Tennessee", where "Battle of Franklin" is not a city, and where the battle's geocoordinates are no more precise than the county. Note that, unlike the Cemetery strings, the "Battle of" string refers to a locale that has County precision, not Location precision.
				<p>I also have a place for the Battle of Chickamauga (also in Tennessee), where the battlefield was larger than a county.  I could specify "Battle of Chickamauga,TN" as a non-county, but instead, I wound up specifying the placename as "Battle of Chickamauga, , Tennessee" (with a double comma) so that the non-town string "battle of" could cause it to having the placelevel (i.e. precision) of "County".<p>
				<p>Note that a Placename Formatting option below tells the Placelevel utility what precision to assign to places whose "town" place-part contains a non-town string. For these "battle" strings, the County Placelevel makes sense.  But you could, instead, specify facility names such as "Church", "Meeting House", "Hospital", etc. and use this field to catch locations that are outside of a town.  I just don't happen to have any such facilities in placenames in my database.</p></div>
			</li>
			<li class='p'>a. <label><b>Strings that identify funky city/town names used in Censuses (Not case-sensitive, etc.):</b><br />
				<textarea disabled rows='2' cols='60'>Beat, Civil District, Division, Election District, Justice Precinct, Magisterial, No Township, Precinct, Rural</textarea></label>
				<br/>b. <b>What to do with these funky city/town names:</b>
				<br/><label><input type='radio' disabled checked />Leave them in the City position and assign the City placelevel</label>
				<br/><label><input type='radio' disabled '/>Remove them</label>
				<br/><label><input type='radio' disabled checked />Move them to the Event description or note</label>
				<div class='comment'>This option is very similar to the two options above, but it differs in that the Placelevel utility will always mark places that contain these strings as "County".</li>
			</li>
		</ol>
		<h4>C. Components of the new placenames</h4>
		<ol start='7'>
			<li><label>Text to represent the USA when there are no subordinate placename components: <input type='text' disabled size='18' value="USA" /></label>
			</li>
			<li><label>Text to represent the USA at the end of a more specific placename: <span class='nw'><input type='text' disabled size='18' value="USA" />
				(Can be blank)</span></label>
				<div class='comment'>There are two options for 'Text to represent the USA' so that, 
				in a USA-centric database, an administrator can specify something for the USA as a full placename (in the first option), while leaving the second option blank so that more detailed placenames end with the state, omitting 'USA' (however it is spelled).  On most TNG sites, both of these options would be the same.
			</li>
				<li>Use <input type='radio' disabled checked>Full state name or 
					<input type='radio' disabled>abbr. for states with a city or county
					<div class='comment'>This option, like several others, goes back to the days when I preferred more cryptic placenames, and I would express the full placename "Tenessee" when the state name is used without a count or city, but use the state abbreviation in placenames that had subordinate locales, such as Tulsa County, OK.
				</li>
			<li><label>Designator (e.g. County, Co, Parish, Par) to identify Counties & Parishes when there IS a city</b>
				<input type='text' disabled value="County,Parish"/></label>
			</li>
			<li><label>Designator to identify Counties & Parishes when there is NOT a city</b>
				<input type='text' disabled value="County,Parish"/></label></li>
				<div class='comment'>Again, the presence of two options here goes back to the says when I used more cryptic placenames.
				With the two options, I could say "County" (or "Co") when it was necessary to avoid ambiguity, e.g. "Dallas Co, TX", and omit the word "County" when the positioning of the County name made it clear that it was a count, e.g. "Dallas, Dallas, TX".
				Note that, because of the Placename Formatting process, when I decided to use names like 
				"Dallas, Dallas County, Texas, USA" instead of "Dallas, Dallas, TX",
				I didn't have edit any placename in my source database.
				Instead, I only had to change the option value in the Gedcom Converter. 
				<p>I suspect that almost all sites will use the value "County, Parish" for both fields.</p>
				</div>
			</li>
			<li class='p'><input type='checkbox' disabled checked />Change 'Ward nn' in city names (e.g. 'Tucson Ward 7,Puma,AZ') as follows:
				<br/><label><input type='radio' disabled />Remove 'Ward nn'</label>
				<br><label><input type='radio' disabled />Move 'Ward nn' to the Location position</label>
				<br><label><input type='radio' disabled checked />Move it to the Event description</label>
				<br><label><input type='radio' disabled />Leave it alone</label>
				<div class='comment'>USA censuses sometimes insert a ward number in city or town names.
				As with the "Funky" town names above, the ward number interfered with Geoding and makes it harder
				to list all of the events that occur within a city.
				But unlike the Funky towns (1970's reference intended :-)), 
				the ward number does not take up an entire place-part -
				until or unless you use one of the action options above to separate it into its own place-part.
				</div>
			</li>
			<li>Omit spaces after commas in placenames (Chicago,Cook,IL and Bethel Cemetery,,,Tennessee,USA)
				<div class='comment'>Some TNG administrators prefer placenames without spaces after the commas, and this option accommodates that format.</div>
			</li>
		</ol>
		<div style='text-align:right;'><button disabled>Save Place Options</button></div>
		</fieldset>
	</td>
</tr>

</table>
</body>
</html>