<?php
# rrplacenameformat_levels.php - Created by Robin Richmond's Place Name Format mod to populate the Placelevel field in the places table. 
# The places must have been formatted according to the Place Name Format Options.
# Placelevel=0 Unknown level
#            1 Address
#            2 Location
#            3 City/Town
#            4 County/Shire
#            5 State/Province
#            6 Country
$placenameformat_cust_text = 1; #This flag causes the Place Name Format strings to be loaded
$tngModNames['Place Name Format']['rrplacenameformat_levels.php'] = '4'; #Register this mod

include("begin.php");
include("adminlib.php");
$textpart = "findplace";
include("getlang.php");
include("checklogin.php");
include("$mylanguage/admintext.php");
$admin_login = 1;
include("version.php");
$helplang = findhelp("places_help.php");
# Include a function library also installed by the Place Name Format mod.
include ('rrplacenameformat_lib.php');

$flags['tabs'] = $tngconfig['tabs'];
tng_adminheader( $admtext['rrpnf-setupplacelevel'], $flags );
?>
<script type="text/javascript" src="js/admin.js"></script>
<script type="text/javascript" language="javascript">
// jQuery function to show/hide a list of places, and switch between buttons that say
// "see them" or "hide them"
function toggleList(thisid) {
	if (jQuery("#"+thisid+"but").val()=="<?php echo $admtext['rrpnf-seethem']; ?>") {
		jQuery("#"+thisid).show();
		jQuery("#"+thisid+"but").val("<?php echo $admtext['rrpnf-hidethem']; ?>");
	} else {
		jQuery("#"+thisid).hide();
		jQuery("#"+thisid+"but").val("<?php echo $admtext['rrpnf-seethem']; ?>");
	}
}
jQuery(document).ready(function() {
	jQuery("#level0listbut").click(
		function(event) { toggleList("level0list"); }
	);
});
</script>
<style>
#level0list {display:none;}
</style>
</head>

<body background="img/background.gif">
<?php

	$placetabs[0] = array(1,"admin_places.php",$admtext['search'],"findplace");
	$placetabs[1] = array($allow_add,"admin_newplace.php",$admtext['addnew'],"addplace");
	$placetabs[2] = array($allow_edit && $allow_delete,"admin_mergeplaces.php",$admtext['merge'],"merge");
	$placetabs[3] = array($allow_edit,"admin_geocodeform.php",$admtext['geocode'],"geo");
	# Add the Copy tab if the Admin Places Data Copy mod has created the Place Data Copy program
	if (file_exists('admin_placedatacopy.php'))
		$placetabs['rrpdc'] = array($allow_edit,"admin_placedatacopy.php",$admtext['rrpdc-copy'],'copy');
	# Add the programs from THIS mod
	$placetabs['rrpnf1'] = array($allow_edit,"rrplacenameformat_levels.php",$admtext['rrpnf-levels'],"level");
	$placetabs['rrpnf2'] = array($allow_edit,"rrplacenameformat_options.php",$admtext['rrpnf-options'],"options");
	# Add the program from RR-Places Short Names last.
	if (file_exists('rrplacesshortnames_dbpopulate.php'))
		$placetabs['rrpsn'] = array($allow_edit && allow_delete,"rrplacesshortnames_dbpopulate.php",$admtext['rrpsn-setupmenu'],"shortnames");

	$innermenu = "<a href=\"#\" onclick=\"return openHelp('$helplang/places_help#levels');\" class=\"lightlink\">{$admtext['help']}</a>";
	$menu = doMenu($placetabs,"level",$innermenu);
	echo displayHeadline($admtext['places'] . " &gt;&gt; " . $admtext['rrpnf-setupplacelevel'], "img/places_icon.gif",$menu,$message);
?>
<table width="100%" border='0' cellpadding='10' cellspacing='2' class='lightback'>
<tr class='databack'>
<td class='tngshadow normal'>

<?php
	#The querystring parameter $tree1 is the selected tree.
	#Restrict it to the assigned tree if appropriate.
	if( $assignedtree ) $tree1 = $assignedtree;
	if( $tngconfig['places1tree'] ) $tree1 = '';

	# Before displaying the form, take any action that was specified by button b1
	if ($b1) {
		if ($b1 == $admtext['rrpnf-completelyrepouplate']) {
			populatePlaceLevel('all', $tree1);
			$message = "Populated all Placelevels.";
 			if ($tree1) $message.= " {$admtext['rrpnf-intree']} $tree1 ";
		}
		else if ($b1 == $admtext['rrpnf-populateundefined']) {
			populatePlaceLevel('undefined', $tree1);
			$message = "Populated undefined Placelevels.";
			if ($tree1) $message.= " {$admtext['rrpnf-intree']} $tree1 ";
		}
		else if ($b1 == $admtext['rrpnf-settozero']) {
			#Set all placelevels for the current tree to zero.
			$treestr = $tree1 ? " WHERE gedcom = \"$tree1\"" : "";
			$query = "UPDATE $places_table SET placelevel=0 $treestr";
			$result = tng_query($query);
			$message = "{$admtext['rrpnf-settozero']}";
			if ($tree1) $message.= " {$admtext['rrpnf-intree']} $tree1 ";
		}
		header( "Location: rrplacenameformat_levels.php?message=" . urlencode($message) );
	}
	# End of actions

	echo "<form>\n";

	#Display a selection list of trees if we need to
	conditionalTreeFormField($tree1);
	
	#Get and display the placelevel counts
	if ($tree1) $wherestr = "WHERE gedcom = \"$tree1\"";
	$query = "SELECT count(*) as total FROM $places_table $wherestr";
	$result = @tng_query($query);
	$row = tng_fetch_assoc($result);
	echo "<br/>Total number of places: {$row['total']}";
	tng_free_result($result);

	if ($wherestr) $wherestr .= ' AND placelevel=0';
	else $wherestr = "WHERE placelevel=0";
	$query = "SELECT gedcom,place FROM $places_table $wherestr ORDER BY gedcom,place;";
	$result = @tng_query($query);
	$total = tng_num_rows($result);
	echo "<br/>Number of places where placelevel is zero: $total ";
	if ($total) {
		echo "<input type=\"button\" id=\"level0listbut\" value=\"{$admtext['rrpnf-seethem']}\" />";
		echo "<ol style=\"border-top:0;border-bottom:0;\" id=\"level0list\">\n";
		while( $row = tng_fetch_assoc($result) ) {
			echo "<li>{$row['gedcom']} - {$row['place']}</li>\n";
		}
		echo '</ol>';
	}
	echo '<br/><br/>';
	tng_free_result($result);

	# Display 3 buttons for the user to choose from.
	echo "<input type='submit' name='b1' value='{$admtext['rrpnf-completelyrepouplate']}' />\n";
	echo "<br>{$admtext['text_or']} <input type='submit' name='b1' value='{$admtext['rrpnf-populateundefined']}'/>\n";
	echo "<br>{$admtext['text_or']} <input type='submit' name='b1' value='{$admtext['rrpnf-settozero']}'/>\n";
?>
	</form>
</td>
</tr>
</table>

<?php
if (file_exists('rrshowmodnames_include.php')) include_once ('rrshowmodnames_include.php'); #List mods
?>
<?php echo "<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version</span></div>"; ?>
</body>
</html>
<?php
###########################################################################
############### End of Mainline code; PHP Functions follow ################
###########################################################################

#########################################################
# Function to display a drop-down list of trees if more than one tree
# is available to the user.
# Generate a hidden field if only one tree is available, and do nothing
# if the 'places1tree' flag is set.
function conditionalTreeFormField($tree1) {
	global $trees_table, $assignedtree;
	
	if ($tngconfig['places1tree']) return;
	
	$treequery = "SELECT gedcom, treename FROM $trees_table ORDER BY treename";
	if( $assignedtree ) $treequery .= " WHERE gedcom='$assignedtree'";
	#Places ARE separated into trees.
	$treeresult = tng_query($treequery);
	if (tng_num_rows($treeresult) == 1) {
		$treerow = tng_fetch_assoc($treeresult);
		echo "<input type=\"hidden\" name=\"tree1\" value=\"{$treerow['gedcom']}\" /></th>\n";
	} else {
		echo "<select name=\"tree1\" onchange=\"this.form.submit();\">\n";
		echo "	<option value=\"\">{$admtext['alltrees']}</option>\n";
		while( $treerow = tng_fetch_assoc($treeresult) ) {
			echo "	<option value=\"{$treerow['gedcom']}\"";
			if( $treerow['gedcom'] == $tree1 ) echo " selected";
			echo ">{$treerow['treename']}</option>\n";
		}
		echo "</select>";
	}
	tng_free_result($treeresult);
} #End of function conditionalTreeFormField

########################################################
#Populate the placelevel field in the Places table.
#The input parameter $whattodo may be "all" or "undefined".  It directs the function to 
#populate all Places records, or only those whose placelevel values are 0.
function populatePlaceLevel($whattodo, $tree1) {
	global $places_table, $admtext;
	global $placeOptions; # Place Name Formatting options

 	$placeOptions = getPlaceNameFormattingParams();

	#Get all placesnames, along with the tree ID, and step through them
	#Ignore placenames whose placelevel is already "Don't geocode"
	$query = "SELECT ID, place, placelevel, gedcom FROM $places_table
		WHERE placelevel >=0 ";
	if ($tree1) $query .= " AND gedcom = '$tree1'";
	if ($whattodo=='0') $query .= " AND placelevel = 0";
	$query .= " ORDER BY gedcom,place";
	$result = tng_query($query);
	$updatecount = 0; #Counts updated places
	echo tng_num_rows($result) . " records selected.";
	while( $row = tng_fetch_assoc($result)) {

		$level=0; #Start by assuming that the level couldn't be set
		$commaParts = explode($placeOptions['delimiter'], trim($row['place']));
		$nparts = count($commaParts)-1;

		# We can recognize All places that are Country only, but after that, we
		#have to focus on non-USA places.
		if ($nparts == 0 )
			$level = 6; #Country.
		elseif ($commaParts[$nparts] == $placeOptions['usaText']) {
			### This is a USA place
			# We need the state abbreviation to look up non-Counties
			if ($placeOptions['useStateAb'] && $nparts>1)
				$stateAb = $commaParts[$nparts-1];
			else $stateAb = $placeOptions['stateNames'][$commaParts[$nparts-1]]; 

			switch ($nparts) {
			case 1: $level = 5; #It must be a state
				break;

			case 2 : # county and state
				#The ambiguous and non-county situations don't matter; they are all level 4
				#xyz What about Henderson, TX????
				$level = 4;
				break;

			case 3 : #(Location or city), (county), (state)
				if (isANonCity($commaParts[0])) {
					switch ($placeOptions['nonCityToDo']) {
						case 'location': $level = 2;
							break;
						case 'city': $level = 3;
							break;
						case 'county': $level = 4;
							break;
						default: #do nthing
					} #end switch 
				} elseif (isABurialPlace($commaParts[0]))
					#Only one option if such a place-part is still in the City position
					$level = 2;
				elseif (isAFunkyTown($commaParts[0]))
					#Only one option if such a place-part is still in the City position
					$level = 4;
				else $level = 3; #City
				break;

			case 4 :  #Must be a location
				$level = 2; #Location
				break;

			default :  #More than 4 positions means Address
				$level = 1; #Location
			} #End of switch on nparts

		} #End If USA place

		if ($level && $level!=$row['placelevel']) {
			#Don't update if the level is still zero or hasn't changed
			$query3 = "UPDATE $places_table SET placelevel = $level WHERE ID = {$row['ID']}";
			tng_query($query3);
			$updatecount++;
		} elseif (!$level) { 
			#Display places we couldn't find a level for.
			echo "<br/> {$admtext['rrpnf-skipped']} {$row['gedcom']}, {$row['place']}, {$admtext['placelevel']}: {$admtext['placelev'][$row['placelevel']]}"; 
		}
	} #End of loop through places
	tng_free_result($result);
	#Display how many places we updated
	echo "<h4>$updatecount {$admtext['rrpnf-levelupdated']}.</h4><hr/>\n";
} #End function populatePlaceLevel 

?>