<?php
# rrplacenameformat_options.php - Options form installed by Robin Richmond's Placename Format Mod
# This program is designed to fit in an Admin>>Places tab.
# The form itself is defined in a function in the include file rrplacenameformat_optionslib.php.
# The form is also also incorporated into a frameset in the Gedcom Converter process kickoff form.
# The options are read from and saved to extensions/rrplacenameformat_config.php.
#
# This program does not do any database access.
$placenameformat_cust_text = 1; #This flag causes the Placename Format strings to be loaded
$tngModNames['Placename Format']['rrplacenameformat_options.php'] = '4'; #Register this mod

include("begin.php");
include("adminlib.php");
$textpart = "findplace";
include("getlang.php");
include("$mylanguage/admintext.php");
$admin_login = 1;
include("checklogin.php");
include("version.php");

$helplang = findhelp("placenameformat_help.php");
$flags['tabs'] = $tngconfig['tabs'];
tng_adminheader( $admtext['rrpnf-pfoptions'], $flags );

include("rrplacenameformat_optionslib.php"); # Function library also installed by the Placename Format mod

?>
<script type="text/javascript" src="js/admin.js?v<?php echo $tng_version; ?>"></script>
<script type="text/javascript" src="js/mediautils.js?v<?php echo $tng_version; ?>"></script>
<style>
	form{margin:0;}
	ul,ol{margin-top:0;margin-bottom:0;}
	ol ol {list-style-type:lower-alpha;}
	legend{font-weight:bold;font-size:90%;}
	.checkbox{ margin: 0 0 0 1.5em;}
	.nowrap{white-space:nowrap;}
	.smallbutton{padding:0 .25em; font-size:85%;}
</style>

<body background="img/background.gif">
<?php

	$placetabs[0] = array(1,"admin_places.php",$admtext['search'],"findplace");
	$placetabs[1] = array($allow_add,"admin_newplace.php",$admtext['addnew'],"addplace");
	$placetabs[2] = array($allow_edit && $allow_delete,"admin_mergeplaces.php",$admtext['merge'],"merge");
	$placetabs[3] = array($allow_edit,"admin_geocodeform.php",$admtext['geocode'],"geo");
	# Add the Copy tab if the Admin Places Data Copy mod has created the Place Data Copy program
	if (file_exists('rrplacedatacopy.php'))
		$placetabs['rrpdc'] = array($allow_edit,"rrplacedatacopy.php",$admtext['rrpdc-copy'],'copy');
	# Add the programs from THIS mod
	$placetabs['rrpnf1'] = array($allow_edit,"rrplacenameformat_levels.php",$admtext['rrpnf-levels'],"level");
	$placetabs['rrpnf2'] = array($allow_edit,"rrplacenameformat_options.php",$admtext['rrpnf-options'],"options");
	# Add the program from RR-Places Short Names last.
	if (file_exists('rrplacesshortnames_dbpopulate.php'))
		$placetabs['rrpsn'] = array($allow_edit && allow_delete,"rrplacesshortnames_dbpopulate.php",$admtext['rrpsn-setupmenu'],"shortnames");


	$innermenu = "<a href=\"#\" onclick=\"return openHelp('$helplang/rrplacenameformat_help');\" class=\"lightlink\">{$admtext['help']}</a>";
	$menu = doMenu($placetabs,"options",$innermenu);
	echo displayHeadline($admtext['places'] . " &gt;&gt; " . $admtext['rrpnf-placenameoptions'], "img/places_icon.gif",$menu,$message);
?>

<table width="100%" border="0" cellpadding="10" cellspacing="2" class="lightback">
<tr class="databack">
<td class="tngshadow normal">
<?php
#This form's data is saved via an action button that calls a JavaScript AJAX function, not a submit button. 
echo "<form id='placeoptionsform' name='placeoptionsform' action=''>\n";
	# These two function from rrplacenameformat_optionslib.php read the places config file,
	# display the form, and generate all of the JavaScript used in the form.
	# The form is saved via an action button that uses Ajax; it does not have a normal submit button.
	getPlaceNameFormattingParams('configfile');
	layOutPlaceNameFormattingFormFields();
?>
</form>
</td>
</tr>
</table>
<?php
if (file_exists('rrshowmodnames_include.php')) include_once ('rrshowmodnames_include.php'); #List mods
?>
<?php echo "<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version</span></div>"; ?>
</body>
</html>
