<?php
# rrplacenameformat_saveoptions.php - Installed by the Placename Format mod, and 
# called via Ajax (using POST) to save the Placename Formatting options from 
# a data entry form to the Placename Format config file.
# The functions read the config file and display the form are in the function library 
# rrplacenameformat_optionslib.php.
# This program does not touch the TNG database. It simply returns the message "Options Saved" when it finishes.

/******************************************
Change history - 
v4 27 Nov 2017
- Several new options as described by the .cfg file, plus some renamed options.
v3 of the Placename Format mod - 20 Jan 2017
- First version in the Placename Format mod
- Called via Ajax rather than included as a function. 
v14 of the Gedcom Converter mod - 28 Oct 2016
- Added options to change the record ID initials for People and Families
*/
$tngModNames['Placename Format']['rrplacenameformat_saveoptions.php'] = '4'; # Register the mod 

include("begin.php");
include("adminlib.php");

# Always write to the same file in the extensions folder.
$outputFilespec = "$extspath/rrplacenameformat_config.php";
$file2 = fopen($outputFilespec,"wt");
fwrite($file2,"<?php\n// rrplacenameformat_config.php\n");
fwrite($file2,"// This config file is read by rrgedcomconverter_form.php, rrplacenameformat_options.php, and other programs\n");
fwrite($file2,"// that use the Placename Formatting options.\n");
fwrite($file2,"// In some cases, programs may read it directly, but programs that can edit the options include it via\n");
fwrite($file2,"// the Include file rrplacenameformat_options_lib.php.\n");
fwrite($file2,"// It is written by rrplacenameformat_saveoptions.php.\n");
fwrite($file2,"// In the Gedcom Converter, rrgedcomconverter_form passes these values on to rrgedcomconverter.php as form parameters.\n");
fwrite($file2,"// The meanings of these values are explained further in the Placename Format help file.\n");
fwrite($file2,"///////\n");
	fwrite($file2,"//Components of existing placenames\n");
	fwrite($file2,"\$usaPossibleValues = \"{$_POST['usaPossibleValues']}\";\n");
	fwrite($file2,"\$extraStateNames = \"{$_POST['statescol1']}\";\n");
	fwrite($file2,"\$extraStateAbbrvs = \"{$_POST['statescol2']}\";\n");
	fwrite($file2,"\$nonCountyLocales = \"{$_POST['nonctycol1']}\";\n");
	fwrite($file2,"\$nonCountyStates = \"{$_POST['nonctycol2']}\";\n");

fwrite($file2,"///////\n");
	fwrite($file2,"\$cemeteryStrings = \"{$_POST['cemeteryStrings']}\";\n");
	fwrite($file2,"\$cemeteryToDo = \"{$_POST['cemeteryToDo']}\";\n");
	fwrite($file2,"\$nonCityStrings = \"{$_POST['nonCityStrings']}\";\n");
	fwrite($file2,"\$nonCityToDo = \"{$_POST['nonCityToDo']}\";\n");
	fwrite($file2,"\$funkyTowns = \"{$_POST['funkyTowns']}\";\n");
	fwrite($file2,"\$funkyTownToDo = \"{$_POST['funkyTownToDo']}\";\n");

fwrite($file2,"///////\n");
	fwrite($file2,"//Components of new placenames\n");
	fwrite($file2,"\$usaTextAlone = \"{$_POST['usaTextAlone']}\";\n");
	fwrite($file2,"\$usaTextWith = \"{$_POST['usaTextWith']}\";\n");
	fwrite($file2,"\$useStateAb = {$_POST['useStateAb']};\n");
	fwrite($file2,"\$countyParishWithCity = \"{$_POST['countyParishWithCity']}\";\n");
	fwrite($file2,"\$countyParishWithoutCity = \"{$_POST['countyParishWithoutCity']}\";\n");

	fwrite($file2,"\$wardToDo = \"{$_POST['wardToDo']}\";\n");
	fwrite($file2,"\$compressPlaces = {$_POST['compressPlaces']};\n");

	#fwrite($file2,"///////\n");
	#fwrite($file2,"//Non-USA Places\n");

	fwrite($file2,"?>\n");
	fclose($file2);
	echo "Options Saved";

#End of rrplacenameformat_saveoptions.php
?>